<?php
//Options for GLPI 0.71 and newer : need slave db to access the report
$USEDBREPLICATE=1;
$DBCONNECTION_REQUIRED=0;

include ("../../inc/includes.php");

Session::checkRight("reports", "r");
Session::checkRight("computer", "r");

#Html::header(Report::getTypeName(2), $_SERVER['PHP_SELF'], "utils", "report");
Html::header("Systèmes d'exploitation par implantation", $_SERVER['PHP_SELF'], "utils", "report");
Report::title();

$computer = new Computer();

$state_sql = "";
if (($state != "") AND ($state != "0")) {
   $state_sql = " AND `states_id` = '".$state."' ";
}

$itemtype = 'Computer';
$table_item = getTableForItemType($itemtype);

echo "<span class='big b'>Systèmes d'exploitation par implantation</span><br><br>";
echo "<table class='tab_cadrehov'>";
echo "<tr class='tab_bg_1'><th>Implantation</th><th>Système d'exploitation</th><th>Quantité</th></tr>";
$green_grand_total = 0;
$yellow_grand_total = 0;
$red_grand_total = 0;
$blue_grand_total = 0;
$grand_total = 0;

# parcours des régions
$query = "SELECT id,name,completename FROM glpi_entities WHERE (id=0 OR entities_id=0)";
$query .= " ".getEntitiesRestrictRequest("AND", "glpi_entities");
$region_result = $DB->query($query);
while ($region_data = $DB->fetch_assoc($region_result)) {
  $region_id = $region_data['id'];
  if ($region_id != 0) {
    $region_name = getTreeLeafValueName("glpi_entities", $region_id);
  } else {
    $region_name = "AUF (non classé)";
  }
  echo "<tr class='tab_bg_1'><td colspan='3' class='b'>$region_name</td></tr>";

  $green_total = 0;
  $yellow_total = 0;
  $red_total = 0;
  $blue_total = 0;
  $region_total = 0;

# operating systems per computer
$query = "SELECT COUNT(c.id) AS count, e.name AS ename,
          (CASE WHEN o.name REGEXP '^Debian ' THEN SUBSTRING_INDEX(REPLACE(o.name,' GNU/Linux',''),'.',1)
                WHEN o.name REGEXP '^Ubuntu ' THEN SUBSTRING_INDEX(REPLACE(o.name,' LTS',''),'.',2)
                WHEN o.name REGEXP '^Microsoft ' THEN REPLACE(o.name,'Microsoft ','')
                WHEN o.name REGEXP '^Mac ' THEN REPLACE(o.name,'Mac ','')
                ELSE o.name END) AS oname
          FROM `$table_item` c
          LEFT JOIN glpi_entities e ON (c.entities_id = e.id)
          LEFT JOIN glpi_operatingsystems o ON (c.operatingsystems_id = o.id)
          WHERE c.is_deleted = '0' AND c.is_template = '0'
          ".getEntitiesRestrictRequest("AND", "c");
if ($region_id != 0) {
  $query .= " AND ".getRealQueryForTreeItem("glpi_entities", $region_id, "e.id");
} else {
  $query .= " AND e.id = '0'";
}
$query .= " GROUP BY 2,3 ORDER BY 2,3";
$result = $DB->query($query);
while ($data=$DB->fetch_assoc($result)) {
  if (empty($data['ename'])) {
    $data['ename'] = "<i>(indéterminé)</i>";
  }
  if (empty($data['oname'])) {
    $data['oname'] = "<i>(indéterminé)</i>";
  }
  if (($data['oname'] == 'Debian 7') || ($data['oname'] == 'Ubuntu 12.04')) {
    $oname_plus = '<svg width="5" height="5" style="background-color: #00ff00; margin: 1px;"/>';
    $green_total += $data['count'];
  } elseif (($data['oname'] == 'Debian 6') || ($data['oname'] == 'Ubuntu 10.04')) {
    $oname_plus = '<svg width="5" height="5" style="background-color: #ffff00; margin: 1px;"/>';
    $yellow_total += $data['count'];
  } elseif ((substr($data['oname'],0,7) == 'Windows') || (substr($data['oname'],strlen($data['oname'])-4,4) == 'OS X')) {
    $oname_plus = '<svg width="5" height="5" style="background-color: #0000ff; margin: 1px;"/>';
    $blue_total += $data['count'];
  } else {
    $oname_plus = '<svg width="5" height="5" style="background-color: #ff0000; margin: 1px;"/>';
    $red_total += $data['count'];
  }
  echo "<tr class='tab_bg_2 auf_show_details'>";
  echo "<td>&nbsp;&nbsp;".$data['ename']."</td>";
  echo "<td>".$oname_plus."&nbsp;".$data['oname']."</td>";
  echo "<td class='numeric'>".$data['count']."</td></tr>";
  $region_total += $data['count'];
}

$green_svg = '<svg width="'.(400*$green_total/$region_total).'" height="5" style="background-color: #00ff00; margin: 1px 0;"/>';
$yellow_svg = '<svg width="'.(400*$yellow_total/$region_total).'" height="5" style="background-color: #ffff00; margin: 1px 0;"/>';
$red_svg = '<svg width="'.(400*$red_total/$region_total).'" height="5" style="background-color: #ff0000; margin: 1px 0;"/>';
$blue_svg = '<svg width="'.(400*$blue_total/$region_total).'" height="5" style="background-color: #0000ff; margin: 1px 0;"/>';
echo "<tr class='tab_bg_2'><td class='b'>&nbsp;&nbsp;Sous-total</td>";
echo "<td>".$green_svg.$yellow_svg.$red_svg.$blue_svg."</td>";
echo "<td class='numeric b'>$region_total</td></tr>";

$green_grand_total += $green_total;
$yellow_grand_total += $yellow_total;
$red_grand_total += $red_total;
$blue_grand_total += $blue_total;
$grand_total += $region_total;
} // fin des régions

echo "<tr class='tab_bg_1'><td colspan='3'>&nbsp;</td></tr>";

# total operating systems
$query = "SELECT COUNT(*) FROM `".$table_item."`
          LEFT JOIN `glpi_computers_items`
          ON (`glpi_computers_items`.`itemtype` = '".$itemtype."'
          AND `glpi_computers_items`.`items_id` = `".$table_item."`.`id`)
          WHERE `".$table_item."`.`is_deleted` = '0'
            AND `".$table_item."`.`is_template` = '0' ".
          getEntitiesRestrictRequest("AND", $table_item);
$result = $DB->query($query);
$total = $DB->result($result, 0, 0);

$green_svg = '<svg width="'.(400*$green_grand_total/$grand_total).'" height="5" style="background-color: #00ff00; margin: 1px 0;"/>';
$yellow_svg = '<svg width="'.(400*$yellow_grand_total/$grand_total).'" height="5" style="background-color: #ffff00; margin: 1px 0;"/>';
$red_svg = '<svg width="'.(400*$red_grand_total/$grand_total).'" height="5" style="background-color: #ff0000; margin: 1px 0;"/>';
$blue_svg = '<svg width="'.(400*$blue_grand_total/$grand_total).'" height="5" style="background-color: #0000ff; margin: 1px 0;"/>';
echo "<tr class='tab_bg_1'><td class='b'>Total général</td>";
echo "<td>".$green_svg.$yellow_svg.$red_svg.$blue_svg."</td>";
echo "<td class='numeric b'>$total</td></tr>";

echo "</table>";

Html::footer();
?>
